
// DLP_ControlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DLP_Control.h"
#include "DLP_ControlDlg.h"
#include "DlgProxy.h"
#include "afxdialogex.h"
#include "API.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CDLP_ControlDlg dialog




IMPLEMENT_DYNAMIC(CDLP_ControlDlg, CDialogEx);

CDLP_ControlDlg::CDLP_ControlDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CDLP_ControlDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;

	m_USB_Connected = false;

    if(USB_IsConnected())
        USB_Close();
    USB_Open();
}

CDLP_ControlDlg::~CDLP_ControlDlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;
}

void CDLP_ControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_CHECK1, m_USB_Connected);
}

BEGIN_MESSAGE_MAP(CDLP_ControlDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CDLP_ControlDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CDLP_ControlDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CDLP_ControlDlg::OnBnClickedButton3)
END_MESSAGE_MAP()


// CDLP_ControlDlg message handlers

BOOL CDLP_ControlDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	ShowWindow(SW_MAXIMIZE);

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDLP_ControlDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDLP_ControlDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDLP_ControlDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void CDLP_ControlDlg::OnClose()
{
	if (CanExit())
		CDialogEx::OnClose();
}

void CDLP_ControlDlg::OnOK()
{
	if (CanExit())
		CDialogEx::OnOK();
}

void CDLP_ControlDlg::OnCancel()
{
	if (CanExit())
		CDialogEx::OnCancel();
}

BOOL CDLP_ControlDlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}



void CDLP_ControlDlg::OnBnClickedButton1()
{

    if(USB_IsConnected())
        USB_Close();
    USB_Open();

    if(USB_IsConnected())
	{
	   // Display GUI Version #
		m_USB_Connected = true;
		((CButton*)GetDlgItem(IDC_CHECK1))->SetCheck(true);
	}
	else
	{
		m_USB_Connected = false;
		((CButton*)GetDlgItem(IDC_CHECK1))->SetCheck(false);
	}
	// TODO: Add your control notification handler code here
}


void CDLP_ControlDlg::OnBnClickedButton2()
{//Power Up
	    if(USB_IsConnected())
        USB_Close();
    USB_Open();

    if(USB_IsConnected())
	{
	   // Display GUI Version #
		m_USB_Connected = true;
		((CButton*)GetDlgItem(IDC_CHECK1))->SetCheck(true);
	}
	else
	{
		m_USB_Connected = false;
		((CButton*)GetDlgItem(IDC_CHECK1))->SetCheck(false);
	}
	DLP_SoftwareReset( );
	DLP_SetPowerMode(false);
	// TODO: Add your control notification handler code here
}


void CDLP_ControlDlg::OnBnClickedButton3()
{//Power Down
	//DLP_SoftwareReset( );
	    if(USB_IsConnected())
        USB_Close();
    USB_Open();

    if(USB_IsConnected())
	{
	   // Display GUI Version #
		m_USB_Connected = true;
		((CButton*)GetDlgItem(IDC_CHECK1))->SetCheck(true);
	}
	else
	{
		m_USB_Connected = false;
		((CButton*)GetDlgItem(IDC_CHECK1))->SetCheck(false);
	}
	DLP_SetPowerMode(true);
	// TODO: Add your control notification handler code here
}
